<script setup lang="ts">
import { api_call } from "@/functions";
import type { API_Cluster_Types } from "@/types";
import { reactive, ref, watch } from "vue";
import ROOT_URL from "@/../settings";

interface Props {
  ocel_file: string;
  clustering_id: string;
  selected_cluster_index: number | null;
}
const props = defineProps<Props>();

const emit = defineEmits<{
  (e: "update:selected_cluster_index", cluster_index: number): void;
}>();

const state = reactive<{
  cluster_list: API_Cluster_Types;
}>({
  cluster_list: [],
});

// eslint-disable-next-line @typescript-eslint/no-explicit-any
const hidden_links = ref<Array<any>>([]);

loadResultList();

async function loadResultList() {
  const response = await api_call(
    "/ocel-cluster/" +
      props.ocel_file +
      "/clustering/" +
      String(props.clustering_id) +
      "/clusters",
    "GET"
  );
  state.cluster_list = (await response.json()).data;
}

function get_download_link(filename: string, cluster_index: number) {
  return (
    ROOT_URL +
    "/ocel-cluster/" +
    filename +
    "/clustering/" +
    props.clustering_id +
    "/clusters/" +
    String(cluster_index)
  );
}

async function download_clicked(filename: string, cluster_index: number) {
  const response = await api_call(
    "/ocel-cluster/" +
      props.ocel_file +
      "/clustering/" +
      String(props.clustering_id) +
      "/clusters/" +
      String(cluster_index),
    "GET"
  );
  const blob = await response.blob();
  const url = URL.createObjectURL(blob);
  hidden_links.value[cluster_index].setAttribute("href", url);
  hidden_links.value[cluster_index].setAttribute(
    "download",
    filename +
      "-cluster-" +
      cluster_index +
      "." +
      state.cluster_list[cluster_index].attributes.filetype
  );
  hidden_links.value[cluster_index].click();
}

function select_cluster(index: number) {
  emit("update:selected_cluster_index", index);
}

watch(
  () => props.clustering_id,
  () => {
    loadResultList();
  }
);
</script>

<template>
  <div class="row border-bottom mb-3 pb-3">
    <h4 class="text-light">Results</h4>
    <div class="col-12">
      <div class="list-group">
        <a
          v-for="(cluster, index) in state.cluster_list"
          :key="index"
          class="list-group-item"
          :class="{
            active: props.selected_cluster_index
              ? props.selected_cluster_index == index
              : false,
          }"
          href="#"
          @click.prevent="select_cluster(index)"
        >
          <div class="d-flex w-100 justify-content-between">
            <span class="align-self-center">cluster-{{ index }}</span>
            <button
              class="btn btn-success btn-sm"
              :download="cluster.id"
              :href="get_download_link(props.ocel_file, index)"
              role="button"
              @click.prevent="download_clicked(props.ocel_file, index)"
            >
              Download OCEL file
            </button>
            <a ref="hidden_links" href="#" download hidden></a>
          </div>
        </a>
      </div>
    </div>
  </div>
</template>
